Creates a C data structure

- « FFI::memset

- FFI::scope »

- PHP Manual
- FFI
- Creates a C data structure

# FFI::new

(PHP 7 >= 7.4.0, PHP 8)

FFI::new — Creates a C data structure

### Description

public FFI::new(FFI\CType|string `$type`, bool `$owned` = `true`, bool `$persistent` = `false`): ?FFI\CData

Creates a native data structure of the given C type. Any type declared for the instance is allowed.

### Parameters

`type`

  `type` is a valid C declaration as string, or an instance of FFI\CType which has already been created.

`owned`

  Whether to create owned (i.e. managed) or unmanaged data. Managed data lives together with the returned FFI\CData object, and is released when the last reference to that object is released by regular PHP reference counting or GC. Unmanaged data should be released by calling FFI::free(), when no longer needed.

`persistent`

  Whether to allocate the C data structure permanently on the system heap (using malloc()), or on the PHP request heap (using emalloc()).

### Return Values

Returns the freshly created FFI\CData object, or `null` on failure.

### Changelog

Version | Description
--- | ---
8.3.0 | Calling FFI::new() statically is now deprecated.